=== debian/changelog ===
herdtools7 (7.58-1) unstable; urgency=medium

  * Initial release. (Closes: #1124402)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 04 Feb 2026 00:10:33 +0100
