=== debian/control ===
Source: herdtools7
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Build-Depends:
 debhelper-compat (= 13),
 dh-ocaml,
 libmenhir-ocaml-dev,
 libzarith-ocaml-dev,
 menhir,
 ocaml,
 ocaml-dune,
 python3,
Rules-Requires-Root: no
Standards-Version: 4.7.3
Homepage: https://github.com/herd/herdtools7
Vcs-Git: https://salsa.debian.org/ocaml-team/herdtools7.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/herdtools7

Package: herdtools7
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Provides: ${ocaml:Provides}
Description: Tool suite to test weak memory models
 herdtools7 is a tool suite to design, simulate and test weak memory models
 which are used in modern CPU architectures. It provides a unified environment
 for generating small concurrent programs (litmus tests), running them on real
 hardware, and simulating them under formal memory‑model specifications.
 By comparing theoretical models with observed hardware behavior, herdtools7
 helps researchers, compiler writers, and systems engineers understand subtle
 ordering effects, validate memory‑model definitions, and reason about
 correctness in highly parallel architectures.
 .
 The tool suite include various tools, including:
  * herd7: a generic simulator for weak memory models
  * litmus7: run litmus tests (given as assembler programs for Power, ARM,
    AArch64 or X86) to test the memory model of the executing machine
  * diy7: produce litmus tests from concise specifications
 .
 herdtools7 is the successor of the diy tool suite.
