=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/ocaml/ocamlvars.mk
export DEB_BUILD_OPTIONS += noautodbgsym

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

execute_before_dh_auto_clean:
	rm -f Version.ml

execute_before_dh_auto_configure:
	make Version.ml
