=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/herd/herdtools7/git/matching-refs/tags/
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
Downloadurlmangle: s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g
Filenamemangle: s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Searchmode: plain
Uversionmangle: s/-(a|alpha|b|beta|c|dev|pre|rc)/~$1/
